Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/Makefile	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -74,4 +74,5 @@
 	app/testwrit \
 	app/tetris \
+	app/tmon \
 	app/trace \
 	app/top \
@@ -151,8 +152,10 @@
 	drv/bus/usb/ohci \
 	drv/bus/usb/uhci \
+	drv/bus/usb/usbdiag \
 	drv/bus/usb/usbflbk \
 	drv/bus/usb/usbhub \
 	drv/bus/usb/usbmid \
 	drv/bus/usb/vhc \
+	drv/bus/usb/xhci \
 	drv/char/i8042 \
 	drv/char/msim-con \
@@ -282,3 +285,2 @@
 
 -include $(DEPS)
-
Index: uspace/app/tmon/Makefile
===================================================================
--- uspace/app/tmon/Makefile	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/Makefile	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,41 @@
+#
+# Copyright (c) 2017 Petr Manek
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from thgis software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+BINARY = tmon
+
+LIBS = drv
+
+SOURCES = \
+	main.c\
+	list.c\
+	tf.c\
+	burst_tests.c\
+	resolve.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/tmon/burst_tests.c
===================================================================
--- uspace/app/tmon/burst_tests.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/burst_tests.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,446 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tmon
+ * @{
+ */
+/**
+ * @file
+ * USB burst tests.
+ */
+
+#include <stdio.h>
+#include <errno.h>
+#include <str.h>
+#include <str_error.h>
+#include <getopt.h>
+#include <usbdiag_iface.h>
+#include <macros.h>
+#include "commands.h"
+#include "tf.h"
+
+#define NAME   "tmon"
+#define INDENT "      "
+
+/** Generic burst test parameters. */
+typedef struct tmon_burst_test_params {
+	/** Inherited base. */
+	tmon_test_params_t base;
+	/** The count of reads/writes to perform. */
+	uint32_t cycles;
+	/** Size of single read/write. */
+	size_t size;
+} tmon_burst_test_params_t;
+
+/** Static array of long options, from which test parameters are parsed. */
+static struct option long_options[] = {
+	{"cycles", required_argument, NULL, 'n'},
+	{"size", required_argument, NULL, 's'},
+	{0, 0, NULL, 0}
+};
+
+/** String of short options, from which test parameters are parsed. */
+static const char *short_options = "n:s:";
+
+/** Common option parser for all burst tests.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ * @param[out] params Parsed test parameters (if successful).
+ *
+ * @return EOK if successful (in such case caller becomes the owner of `params`).
+ */
+static int read_params(int argc, char *argv[], tmon_test_params_t **params)
+{
+	int rc;
+	tmon_burst_test_params_t *p = (tmon_burst_test_params_t *) malloc(sizeof(tmon_burst_test_params_t));
+	if (!p)
+		return ENOMEM;
+
+	// Default values.
+	p->cycles = 256;
+	p->size = 1024;
+
+	// Parse other than default values.
+	int c;
+	for (c = 0, optreset = 1, optind = 0; c != -1;) {
+		c = getopt_long(argc, argv, short_options, long_options, NULL);
+		switch (c) {
+		case -1:
+			break;
+		case 'n':
+			if (!optarg || str_uint32_t(optarg, NULL, 10, false, &p->cycles) != EOK) {
+				puts(NAME ": Invalid number of cycles.\n");
+				rc = EINVAL;
+				goto err_malloc;
+			}
+			break;
+		case 's':
+			if (!optarg || str_size_t(optarg, NULL, 10, false, &p->size) != EOK) {
+				puts(NAME ": Invalid data size.\n");
+				rc = EINVAL;
+				goto err_malloc;
+			}
+			break;
+		}
+	}
+
+	*params = (tmon_test_params_t *) p;
+	return EOK;
+
+err_malloc:
+	free(p);
+	*params = NULL;
+	return rc;
+}
+
+/** Unit of quantity used for pretty formatting. */
+typedef struct tmon_unit {
+	/** Prefix letter, which is printed before the actual unit. */
+	char prefix;
+	/** Factor of the unit. */
+	uint64_t factor;
+} tmon_unit_t;
+
+/** Static array of units with decreasing factors. */
+static const tmon_unit_t units[] = {
+	{ .prefix = 'E', .factor = ((uint64_t) 1) << 60 },
+	{ .prefix = 'P', .factor = ((uint64_t) 1) << 50 },
+	{ .prefix = 'T', .factor = ((uint64_t) 1) << 40 },
+	{ .prefix = 'G', .factor = ((uint64_t) 1) << 30 },
+	{ .prefix = 'M', .factor = ((uint64_t) 1) << 20 },
+	{ .prefix = 'k', .factor = ((uint64_t) 1) << 10 }
+};
+
+/** Format size in bytes for human reading.
+ * @param[in] size The size to format.
+ * @param[in] fmt Format string. Must include one double and char.
+ *
+ * @return Heap-allocated string if successful (caller becomes its owner), NULL otherwise.
+ */
+static char * format_size(double size, const char *fmt)
+{
+	// Figure out the "tightest" unit.
+	unsigned i;
+	for (i = 0; i < ARRAY_SIZE(units); ++i) {
+		if (units[i].factor <= size)
+			break;
+	}
+
+	char prefix[] = { '\0', '\0' };
+	double factor = 1;
+
+	if (i < ARRAY_SIZE(units)) {
+		prefix[0] = units[i].prefix;
+		factor = units[i].factor;
+	}
+
+	// Format the size.
+	const double div_size = size / factor;
+
+	char *out = NULL;
+	asprintf(&out, fmt, div_size, prefix);
+
+	return out;
+}
+
+/** Print burst test parameters.
+ * @param[in] params Test parameters to print.
+ */
+static void print_params(const tmon_burst_test_params_t *params)
+{
+	printf(INDENT "Number of cycles: %d\n", params->cycles);
+
+	char *str_size = format_size(params->size, "%.3f %sB");
+	printf(INDENT "Data size: %s\n", str_size);
+	free(str_size);
+}
+
+/** Print burst test results.
+ * @param[in] params Test parameters.
+ * @param[in] duration Duration of the burst test.
+ */
+static void print_results(const tmon_burst_test_params_t *params, usbdiag_dur_t duration)
+{
+	printf(INDENT "Total duration: %ld ms\n", duration);
+
+	const double dur_per_cycle = (double) duration / (double) params->cycles;
+	printf(INDENT "Duration per cycle: %.3f ms\n", dur_per_cycle);
+
+	const size_t total_size = params->size * params->cycles;
+	char *str_total_size = format_size(total_size, "%.3f %sB");
+	printf(INDENT "Total size: %s\n", str_total_size);
+	free(str_total_size);
+
+	const double speed = 1000.0 * (double) total_size / (double) duration;
+	char *str_speed = format_size(speed, "%.3f %sB/s");
+	printf(INDENT "Average speed: %s\n", str_speed);
+	free(str_speed);
+}
+
+/** Run "interrupt in" burst test.
+ * @param[in] exch Open async exchange with the diagnostic device.
+ * @param[in] generic_params Test parameters. Must point to 'tmon_burst_test_params_t'.
+ *
+ * @return Exit code
+ */
+static int run_intr_in(async_exch_t *exch, const tmon_test_params_t *generic_params)
+{
+	const tmon_burst_test_params_t *params = (tmon_burst_test_params_t *) generic_params;
+	puts("Reading data from interrupt endpoint.\n");
+	print_params(params);
+
+	usbdiag_dur_t duration;
+	int rc = usbdiag_burst_intr_in(exch, params->cycles, params->size, &duration);
+	if (rc) {
+		printf(NAME ": Test failed with error: %s\n", str_error(rc));
+		return 1;
+	}
+
+	puts("Test succeeded.\n");
+	print_results(params, duration);
+	return 0;
+}
+
+/** Run "interrupt out" burst test.
+ * @param[in] exch Open async exchange with the diagnostic device.
+ * @param[in] generic_params Test parameters. Must point to 'tmon_burst_test_params_t'.
+ *
+ * @return Exit code
+ */
+static int run_intr_out(async_exch_t *exch, const tmon_test_params_t *generic_params)
+{
+	const tmon_burst_test_params_t *params = (tmon_burst_test_params_t *) generic_params;
+	puts("Writing data to interrupt endpoint.\n");
+	print_params(params);
+
+	usbdiag_dur_t duration;
+	int rc = usbdiag_burst_intr_out(exch, params->cycles, params->size, &duration);
+	if (rc) {
+		printf(NAME ": Test failed with error: %s\n", str_error(rc));
+		return 1;
+	}
+
+	puts("Test succeeded.\n");
+	print_results(params, duration);
+	return 0;
+}
+
+/** Run "bulk in" burst test.
+ * @param[in] exch Open async exchange with the diagnostic device.
+ * @param[in] generic_params Test parameters. Must point to 'tmon_burst_test_params_t'.
+ *
+ * @return Exit code
+ */
+static int run_bulk_in(async_exch_t *exch, const tmon_test_params_t *generic_params)
+{
+	const tmon_burst_test_params_t *params = (tmon_burst_test_params_t *) generic_params;
+	puts("Reading data from bulk endpoint.\n");
+	print_params(params);
+
+	usbdiag_dur_t duration;
+	int rc = usbdiag_burst_bulk_in(exch, params->cycles, params->size, &duration);
+	if (rc) {
+		printf(NAME ": Test failed with error: %s\n", str_error(rc));
+		return 1;
+	}
+
+	puts("Test succeeded.\n");
+	print_results(params, duration);
+	return 0;
+}
+
+/** Run "bulk out" burst test.
+ * @param[in] exch Open async exchange with the diagnostic device.
+ * @param[in] generic_params Test parameters. Must point to 'tmon_burst_test_params_t'.
+ *
+ * @return Exit code
+ */
+static int run_bulk_out(async_exch_t *exch, const tmon_test_params_t *generic_params)
+{
+	const tmon_burst_test_params_t *params = (tmon_burst_test_params_t *) generic_params;
+	puts("Writing data to bulk endpoint.\n");
+	print_params(params);
+
+	usbdiag_dur_t duration;
+	int rc = usbdiag_burst_bulk_out(exch, params->cycles, params->size, &duration);
+	if (rc) {
+		printf(NAME ": Test failed with error: %s\n", str_error(rc));
+		return 1;
+	}
+
+	puts("Test succeeded.\n");
+	print_results(params, duration);
+	return 0;
+}
+
+/** Run "isochronous in" burst test.
+ * @param[in] exch Open async exchange with the diagnostic device.
+ * @param[in] generic_params Test parameters. Must point to 'tmon_burst_test_params_t'.
+ *
+ * @return Exit code
+ */
+static int run_isoch_in(async_exch_t *exch, const tmon_test_params_t *generic_params)
+{
+	const tmon_burst_test_params_t *params = (tmon_burst_test_params_t *) generic_params;
+	puts("Reading data from isochronous endpoint.\n");
+	print_params(params);
+
+	usbdiag_dur_t duration;
+	int rc = usbdiag_burst_isoch_in(exch, params->cycles, params->size, &duration);
+	if (rc) {
+		printf(NAME ": Test failed with error: %s\n", str_error(rc));
+		return 1;
+	}
+
+	puts("Test succeeded.\n");
+	print_results(params, duration);
+	return 0;
+}
+
+/** Run "isochronous out" burst test.
+ * @param[in] exch Open async exchange with the diagnostic device.
+ * @param[in] generic_params Test parameters. Must point to 'tmon_burst_test_params_t'.
+ *
+ * @return Exit code
+ */
+static int run_isoch_out(async_exch_t *exch, const tmon_test_params_t *generic_params)
+{
+	const tmon_burst_test_params_t *params = (tmon_burst_test_params_t *) generic_params;
+	puts("Writing data to isochronous endpoint.\n");
+	print_params(params);
+
+	usbdiag_dur_t duration;
+	int rc = usbdiag_burst_isoch_out(exch, params->cycles, params->size, &duration);
+	if (rc) {
+		printf(NAME ": Test failed with error: %s\n", str_error(rc));
+		return 1;
+	}
+
+	puts("Test succeeded.\n");
+	print_results(params, duration);
+	return 0;
+}
+
+/** Interrupt in burst test command handler.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int tmon_burst_intr_in(int argc, char *argv[])
+{
+	static const tmon_test_ops_t ops = {
+		.run = run_intr_in,
+		.read_params = read_params
+	};
+
+	return tmon_test_main(argc, argv, &ops);
+}
+
+/** Interrupt out burst test command handler.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int tmon_burst_intr_out(int argc, char *argv[])
+{
+	static const tmon_test_ops_t ops = {
+		.run = run_intr_out,
+		.read_params = read_params
+	};
+
+	return tmon_test_main(argc, argv, &ops);
+}
+
+/** Interrupt bulk burst test command handler.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int tmon_burst_bulk_in(int argc, char *argv[])
+{
+	static const tmon_test_ops_t ops = {
+		.run = run_bulk_in,
+		.read_params = read_params
+	};
+
+	return tmon_test_main(argc, argv, &ops);
+}
+
+/** Bulk out burst test command handler.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int tmon_burst_bulk_out(int argc, char *argv[])
+{
+	static const tmon_test_ops_t ops = {
+		.run = run_bulk_out,
+		.read_params = read_params
+	};
+
+	return tmon_test_main(argc, argv, &ops);
+}
+
+/** Isochronous in burst test command handler.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int tmon_burst_isoch_in(int argc, char *argv[])
+{
+	static const tmon_test_ops_t ops = {
+		.run = run_isoch_in,
+		.read_params = read_params
+	};
+
+	return tmon_test_main(argc, argv, &ops);
+}
+
+/** Isochronous out burst test command handler.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int tmon_burst_isoch_out(int argc, char *argv[])
+{
+	static const tmon_test_ops_t ops = {
+		.run = run_isoch_out,
+		.read_params = read_params
+	};
+
+	return tmon_test_main(argc, argv, &ops);
+}
+
+/** @}
+ */
Index: uspace/app/tmon/commands.h
===================================================================
--- uspace/app/tmon/commands.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/commands.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tmon
+ * @{
+ */
+/**
+ * @file USB diagnostic device commands.
+ */
+
+#ifndef TMON_COMMANDS_H_
+#define TMON_COMMANDS_H_
+
+/* All commands are just versions of int main(int, char **). */
+
+/* List command just prints compatible devices. */
+int tmon_list(int, char **);
+
+/* Burst tests read/write into endpoints as fast as possible. */
+int tmon_burst_intr_in(int, char **);
+int tmon_burst_intr_out(int, char **);
+int tmon_burst_bulk_in(int, char **);
+int tmon_burst_bulk_out(int, char **);
+int tmon_burst_isoch_in(int, char **);
+int tmon_burst_isoch_out(int, char **);
+
+#endif /* TMON_COMMANDS_H_ */
+
+/** @}
+ */
Index: uspace/app/tmon/list.c
===================================================================
--- uspace/app/tmon/list.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/list.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,100 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tmon
+ * @{
+ */
+/**
+ * @file
+ * USB transfer debugging.
+ */
+
+#include <stdio.h>
+#include <devman.h>
+#include <loc.h>
+#include <usbdiag_iface.h>
+#include "commands.h"
+
+#define NAME "tmon"
+#define MAX_PATH_LENGTH 1024
+
+/** Print a single item of the device list.
+ * @param[in] svc Service ID of the devman function.
+ */
+static void print_list_item(service_id_t svc)
+{
+	int rc;
+	devman_handle_t diag_handle = 0;
+
+	if ((rc = devman_fun_sid_to_handle(svc, &diag_handle))) {
+		printf(NAME ": Error resolving handle of device with SID %" PRIun ", skipping.\n", svc);
+		return;
+	}
+
+	char path[MAX_PATH_LENGTH];
+	if ((rc = devman_fun_get_path(diag_handle, path, sizeof(path)))) {
+		printf(NAME ": Error resolving path of device with SID %" PRIun ", skipping.\n", svc);
+		return;
+	}
+
+	printf("%s\n", path);
+}
+
+/** List command handler.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int tmon_list(int argc, char *argv[])
+{
+	category_id_t diag_cat;
+	service_id_t *svcs;
+	size_t count;
+	int rc;
+
+	if ((rc = loc_category_get_id(USBDIAG_CATEGORY, &diag_cat, 0))) {
+		printf(NAME ": Error resolving category '%s'", USBDIAG_CATEGORY);
+		return 1;
+	}
+
+	if ((rc = loc_category_get_svcs(diag_cat, &svcs, &count))) {
+		printf(NAME ": Error getting list of diagnostic devices.\n");
+		return 1;
+	}
+
+	for (unsigned i = 0; i < count; ++i) {
+		print_list_item(svcs[i]);
+	}
+
+	free(svcs);
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/app/tmon/main.c
===================================================================
--- uspace/app/tmon/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,165 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tmon
+ * @{
+ */
+/**
+ * @file
+ * USB transfer debugging.
+ */
+
+#include <stdio.h>
+#include <stddef.h>
+#include <str.h>
+#include <macros.h>
+#include "commands.h"
+
+#define NAME   "tmon"
+#define INDENT "      "
+
+/** Command which is executed by tmon. */
+typedef struct tmon_cmd {
+	/** Unique name, by which the command is executed. */
+	const char *name;
+	/** Description of the command, which is displayed in the usage string. */
+	const char *description;
+	/** Function, which executes the command. Same as int main(int, char**). */
+	int (*action)(int, char **);
+} tmon_cmd_t;
+
+/** Static array of commands supported by tmon. */
+static tmon_cmd_t commands[] = {
+	{
+		.name = "list",
+		.description = "Print a list of connected diagnostic devices.",
+		.action = tmon_list,
+	},
+	{
+		.name = "test-intr-in",
+		.description = "Read from interrupt endpoint as fast as possible.",
+		.action = tmon_burst_intr_in,
+	},
+	{
+		.name = "test-intr-out",
+		.description = "Write to interrupt endpoint as fast as possible.",
+		.action = tmon_burst_intr_out,
+	},
+	{
+		.name = "test-bulk-in",
+		.description = "Read from bulk endpoint as fast as possible.",
+		.action = tmon_burst_bulk_in,
+	},
+	{
+		.name = "test-bulk-out",
+		.description = "Write to bulk endpoint as fast as possible.",
+		.action = tmon_burst_bulk_out,
+	},
+	{
+		.name = "test-isoch-in",
+		.description = "Read from isochronous endpoint as fast as possible.",
+		.action = tmon_burst_isoch_in,
+	},
+	{
+		.name = "test-isoch-out",
+		.description = "Write to isochronous endpoint as fast as possible.",
+		.action = tmon_burst_isoch_out,
+	}
+};
+
+/** Option shown in the usage string. */
+typedef struct tmon_opt {
+	/** Long name of the option without "--" prefix. */
+	const char *long_name;
+	/** Short name of the option without "-" prefix. */
+	char short_name;
+	/** Description of the option displayed in the usage string. */
+	const char *description;
+} tmon_opt_t;
+
+/** Static array of options displayed in the tmon usage string. */
+static tmon_opt_t options[] = {
+	{
+		.long_name = "cycles",
+		.short_name = 'n',
+		.description = "Set the number of read/write cycles."
+	},
+	{
+		.long_name = "size",
+		.short_name = 's',
+		.description = "Set the data size transferred in a single cycle."
+	}
+};
+
+/** Print usage string.
+ * @param[in] app_name Name to print in the invocation example.
+ */
+static void print_usage(char *app_name)
+{
+	puts(NAME ": benchmark USB diagnostic device\n\n");
+	printf("Usage: %s command [device] [options]\n\n", app_name);
+
+	for (unsigned i = 0; i < ARRAY_SIZE(commands); ++i) {
+		printf(INDENT "%s - %s\n", commands[i].name, commands[i].description);
+	}
+
+	puts("\n");
+	for (unsigned i = 0; i < ARRAY_SIZE(options); ++i) {
+		printf(INDENT "-%c --%s\n" INDENT INDENT "%s\n", options[i].short_name, options[i].long_name, options[i].description);
+	}
+
+	puts("\nIf no device is specified, the first device is used provided that it is the only one connected. Otherwise, the command fails.\n\n");
+}
+
+/** Main tmon entry point.
+ * @param[in] argc Number of arguments.
+ * @param[in] argv Argument values. Must point to exactly `argc` strings.
+ *
+ * @return Exit code
+ */
+int main(int argc, char *argv[])
+{
+	// Find a command to execute.
+	tmon_cmd_t *cmd = NULL;
+	for (unsigned i = 0; argc > 1 && i < ARRAY_SIZE(commands); ++i) {
+		if (str_cmp(argv[1], commands[i].name) == 0) {
+			cmd = commands + i;
+			break;
+		}
+	}
+
+	if (!cmd) {
+		print_usage(argv[0]);
+		return -1;
+	}
+
+	return cmd->action(argc - 1, argv + 1);
+}
+
+/** @}
+ */
Index: uspace/app/tmon/resolve.c
===================================================================
--- uspace/app/tmon/resolve.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/app/tmon/resolve.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,105 @@
+/*
+ * Copyright (c) 2017 Petr Manek
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tmon
+ * @{
+ */
+/**
+ * @file
+ * USB diagnostic device resolving.
+ */
+
+#include <loc.h>
+#include <errno.h>
+#include <str_error.h>
+#include <stdio.h>
+#include <usbdiag_iface.h>
+#include "resolve.h"
+
+#define NAME "tmon"
+
+/** Resolve a single function by its class (fail if there is more/less than 1).
+ * @param[out] fun Resolved function handle (if found).
+ *
+ * @return EOK if the function was resolved successfully.
+ */
+int tmon_resolve_default(devman_handle_t *fun)
+{
+	category_id_t diag_cat;
+	service_id_t *svcs;
+	size_t count;
+	int rc;
+
+	if ((rc = loc_category_get_id(USBDIAG_CATEGORY, &diag_cat, 0))) {
+		printf(NAME ": Error resolving category '%s'", USBDIAG_CATEGORY);
+		return rc;
+	}
+
+	if ((rc = loc_category_get_svcs(diag_cat, &svcs, &count))) {
+		printf(NAME ": Error getting list of diagnostic devices.\n");
+		return rc;
+	}
+
+	// There must be exactly one diagnostic device for this to work.
+	if (count != 1) {
+		if (count) {
+			printf(NAME ": Found %zu devices. Please specify which to use.\n", count);
+		} else {
+			printf(NAME ": No diagnostic devices found.\n");
+		}
+		return ENOENT;
+	}
+
+	if ((rc = devman_fun_sid_to_handle(svcs[0], fun))) {
+		printf(NAME ": Error resolving handle of device with "
+		    "SID %" PRIun ".\n", svcs[0]);
+		return rc;
+	}
+
+	return EOK;
+}
+
+/** Resolve a function by its name or device path.
+ * @param[in] dev_path Name or device path (see `devman_fun_get_handle` for possible values).
+ * @param[out] fun Resolved function handle (if found).
+ *
+ * @return EOK if the function was resolved successfully.
+ */
+int tmon_resolve_named(const char *dev_path, devman_handle_t *fun)
+{
+	int rc;
+	if ((rc = devman_fun_get_handle(dev_path, fun, 0))) {
+		printf(NAME ": Error resolving handle of device - %s.\n", str_error(rc));
+		return rc;
+	}
+
+	return EOK;
+}
+
+/** @}
+ */
